%define anolis_release 2
Summary: Garbage collector for C and C++
Name:    gc
Version: 8.2.0
Release: %{anolis_release}%{dist}

License: BSD
URL:     https://www.hboehm.info/gc/
Source0: https://github.com/ivmai/bdwgc/releases/download/v%{version}/gc-%{version}%{?pre}.tar.gz

Patch0001: 0001-Distribute-gc_gcj.h-and-some-other-headers-in-single.patch

BuildRequires: automake libtool
BuildRequires: gcc-c++
BuildRequires: pkgconfig
BuildRequires: make

Obsoletes: libgc < %{version}-%{release}
Provides:  libgc = %{version}-%{release}

%description
The Boehm-Demers-Weiser conservative garbage collector can be
used as a garbage collecting replacement for C malloc or C++ new.

%package devel
Summary: Libraries and header files for %{name} development
Requires: %{name}%{?_isa} = %{version}-%{release}
Obsoletes: libgc-devel < %{version}-%{release}
Provides:  libgc-devel = %{version}-%{release}
%description devel
%{summary}.


%prep
%autosetup -n bdwgc-%{version}%{?pre} -p1


%build
# refresh auto*/libtool to purge rpaths
rm -f libtool libtool.m4
autoreconf -i -f

CPPFLAGS="-DUSE_GET_STACKBASE_FOR_MAIN"; export CPPFLAGS

%configure \
  --disable-docs \
  --enable-cplusplus \
  --enable-large-config \
  --enable-threads=posix

%make_build


%install
%make_install

install -p -D -m644 doc/gc.man  %{buildroot}%{_mandir}/man3/gc.3

## Unpackaged files
rm -rfv %{buildroot}%{_datadir}/gc/
rm -fv  %{buildroot}%{_libdir}/lib*.la


%check
%ifnarch aarch64
make check %{?arch_ignore}
%endif


%ldconfig_scriptlets

%files
%{_libdir}/libcord.so.1*
%{_libdir}/libgc.so.1*
%{_libdir}/libgccpp.so.1*
%{_libdir}/libgctba.so*

%files devel
%doc doc/README.environment doc/README.linux
%doc doc/*.md
%{_includedir}/gc.h
%{_includedir}/gc_cpp.h
%{_includedir}/gc/
%{_libdir}/libcord.so
%{_libdir}/libgc.so
%{_libdir}/libgctba.so*
%{_libdir}/libgccpp.so
%{_libdir}/pkgconfig/bdw-gc.pc
%{_mandir}/man3/gc.3*


%changelog 
* Wed Apr 21 2022 Zhongling He <zhonglingh@linux.alibaba.com> 8.2.0-2
- Backport c876dc2 from upstream to fix some headers not installed.

* Wed Apr 13 2022 Zhongling He <zhonglingh@linux.alibaba.com> 8.2.0-1
- Init package from upstream v8.2.0
